$debug
c
c
c
c
c	VertTD01.for fils de HoriTD03.for
c	Programme de calcul des cartes d'ecoulement
c     par la methode de Taitel et Dukler
c	Ecoulement vertical
c	
c	Dclarations de types et organisatlon memoire
c	Version double prcision
c	E/S adaptes au trac
c
c
	implicit real*8 (a-h,o-z)
	integer*4 System
c
	character *40 parnm1(7),titre1,parnm2(6),titre2
	common/taitel/pi,g,rl,rg,anul,anug,diam,alp,
	&             y,z,cl,cg,an,am,turbl,turbg,
	&             sg, cost ,sint,sl,si,ag,al,ug,ul,dg,dl,
	&             a,b,c,d,e,xl,xg,fr2,rel,ajl,ajg
c
	dimension par1(7), par2(6)
	equivalence (sg,th)
c
c
	data titre1/'CARTE D''ECOULEMENT DE TAITEL ET DUKLER'/
      data parnm1/'MASSE VOLUMIQUE OU GAZ en kg/m3',
	&            'MASSE VOLUMIQUE OU LIQ. en kg/m3',
	&            'VISCOSITE DYNAMIQUE DU GAZ en Pa s',
	&            'VISCOSITE DYNAMIQUE DU LIQ. en Pa s',
	&            'TENSION DE SURFACE G-L en N/m',
	&            'DIAMETRE DU TUBE en mm',
	&            'LONGUEUR OU TUBE en m'/
c
	data par1/1.20d0,1000d0,18.12d-6,1.d-3,0.072d0,25.d0,2.5d0/
c
	data titre2/'PARAMETRES DE LA CARTE '/
	data parnm2/'VIT. superficielle GAZ. MINI en m/s',
     &            'VIT. superficielle GAZ MAXI en m/s',
     &            'VIT. superficielle LIQ. MINI en m/s',
     &            'VIT. superficielle LIQ. MAXI en m/s',
     &            'Nombre de points par decade (GAZ) ',
     &            'Nombre de points par decade (LIQ) '/
c
      data par2/.02d0,200d0,.002d0,20d0,20d0,20d0/
c
      pi=4.d0*datan(1.d0)
c
	open(6,file='VertTD02.out')
	open(7,file='VertTD02.plp')
c
c  introduction des parametres du probleme
c
	call lire(titre1,7,parnm1,par1,'1pe12.3')

c  affectation des parametres

	rg=par1(1)
	rl=par1(2)
	amug=par1(3)
	amul=par1(4)
	anug = amug/rg
	anul = amul/rl
	sig=par1(5)
	diam=par1(6)/1000d0
	aL = par1(7)
c
c
c	
c	parametres descriptifs de la carte
c
c
	call lire(titre2,6,parnm2,par2,'f12.5')
c
c	affectation des parametres
c	
      ajgmin=par2(1)
	ajgmax=par2(2)
	ajlmin=par2(3)
	ajlmax=par2(4)
	djg=10.d0**(1.d0/par2(5))
	djl=10.d0**(1.d0/par2(6))

	write(7,'('' set xrange['',1pE10.3,'':'',1pE10.3,'']'')')
	&         ajgmin,ajgmax
	write(7,'('' set yrange['',1pE10.3,'':'',1pE10.3,'']'')')
	&         ajlmin,ajlmax
c
c	initialisation des constantes
c
	g=9.81d0
	aLsD=aL/diam
	u0inf = 1.53d0*(g*(rl-rg)*sig/rl/rl)**.25d0
c	write(*,*)U0inf
c
c	critre du petit diamtre de conduite
c
	if(dsqrt(diam).le.3.78*(sig*(rl-rg)/rl**2/g)**.25d0)then
	write(7,'('' larg=1'')')
	else
	write(7,'('' larg=3'')')
	endif

c
c	Point triple E-F
c
	alphaT=0.25d0
	aJM112=3.d0*(sig/rl)**.1d0*diam**.48d0/(rl/(rl-rg)/g)**.5d0
	&           /anul**.08d0
	aJM = aJM112**(1.d0/1.12d0)
	aJGEF = alphaT*(aJM+(1-alphaT)**1.5d0*U0inf)
	aJLEF = aJM-aJGEF
c	write(*,'(1p2e14.6)')aJGEF,aJLEF
c	read(*,*)


c
c
c	Transition Bulles-intermittent
c	transition E

c
	aJL=ajlmin
	alphaT=0.25d0
c
	write(6,'(''Transtion E'')')
1	continue
	aJG = alphaT/(1.d0-alphaT)*(aJL+(1-alphaT)**1.5d0*U0inf)
	write(6,'(1p2e14.6)')aJG,aJL
c	write(*,'(1p2e14.6)')aJG,aJL
	aJL = aJL*dJL
	if(aJL.lt.aJLEF) goto 1
	write(6,'(1p2e14.6)')aJGEF,aJLEF
	write(6,'(/)')
c
c	Point triple E-G
c
	alphaT=0.52d0
	aJM112=3.d0*(sig/rl)**.1d0*diam**.48d0/(rl/(rl-rg)/g)**.5d0
	&           /anul**.08d0
	aJM = aJM112**(1.d0/1.12d0)
	aJGEG = alphaT*(aJM+(1-alphaT)**1.5d0*U0inf)
	aJLEG = aJM-aJGEG
c	write(*,'(1p2e14.6)')aJGEG,aJLEG
c	read(*,*)
c
c	Point triple GJ
c
	alphaT=0.52d0
	aJGGJ = 3.1d0*(sig*g*(rl-rg))**.25d0/rg**.5d0
	aJLGJ = (1.d0-alphaT)/alphaT*aJGGJ-(1.d0-alphaT)**1.5d0*U0inf
c	write(*,'(1p2e14.6)')aJGGJ,aJLGJ
c	read(*,*)

c
c
c	Transition Bulles disperses-intermittent
c	transition G
c
	aJL=ajlmin
	alphaT=0.52d0
c
	write(6,'(''Transtion G'')')
	write(6,'(1p2e14.6)')aJGEG,aJLEG
2	continue
	aJG = alphaT/(1.d0-alphaT)*(aJL+(1-alphaT)**1.5d0*U0inf)
	if(aJL.gt.aJLEF)then
	write(6,'(1p2e14.6)')aJG,aJL
c	write(*,'(1p2e14.6)')aJG,aJL
	endif
	aJL = aJL*dJL
	if(aJL.lt.aJLGJ) goto 2
	write(6,'(1p2e14.6)')aJGGJ,aJLGJ
	write(6,'(/)')


c
c
c	Transition Bulles disperses-Bulles
c	transition F

c
	aJG=ajgmin
c
	write(6,'(''Transtion F'')')
3	continue
	aJM112=3.d0*(sig/rl)**.1d0*diam**.48d0/(rl/(rl-rg)/g)**.5d0
	&           /anul**.08d0
	aJM=aJM112**(1.d0/1.12d0)
	aJL=aJM-aJG
	write(6,'(1p2e14.6)')aJG,aJL
c	write(*,'(1p2e14.6)')aJG,aJL
	aJg = aJg*dJg
	if(aJg.lt.aJGEG) goto 3
	write(6,'(1p2e14.6)')aJGEG,aJLEG
	write(6,'(/)')

c
c	Point triple H-E
c
	alphaT=0.25d0
	aJM=dsqrt(g*diam)*(aLsD/42.6d0-0.29d0)
	aJGHE = alphaT*(aJM+(1-alphaT)**1.5d0*U0inf)
	aJLHE = aJM-aJGHE
c	write(*,'(1p2e14.6)')aJGHE,aJLHE
c	read(*,*)
	aJGHEG =aJGHE
	aJLHEG =aJLHE

c
c
c	Point triple H-G
c
	alphaT=0.52d0
	aJM=dsqrt(g*diam)*(aLsD/42.6d0-0.29d0)
	aJGHG = alphaT*(aJM+(1-alphaT)**1.5d0*U0inf)
	aJLHG = aJM-aJGHG
c	write(*,'(1p2e14.6)')aJGHG,aJLHG
c	read(*,*)
	if(aJGHE.gt.aJGEF)then
	aJGHEG =aJGHG
	aJLHEG =aJLHG
	endif

c
c
c	Transition Intermittent-Churn
c	transition H

c
	aJL=ajlmin
c
	write(6,'(''Transtion H'')')
4	continue
	aJM=dsqrt(g*diam)*(aLsD/42.6d0-0.29d0)
	aJG=aJM-aJL
	write(6,'(1p2e14.6)')aJG,aJL
c	write(*,'(1p2e14.6)')aJG,aJL
	aJL = aJL*dJl
	if(aJl.lt.aJLHEG) goto 4
	write(6,'(1p2e14.6)')aJGHEG,aJLHEG
	write(6,'(/)')
c
c
c	Transition from annular flow
c	transition J

c
	aJL=ajlmin
c
	write(6,'(''Transtion J'')')
5	continue
	aJG = 3.1d0*(sig*g*(rl-rg))**.25d0/rg**.5d0
	write(6,'(1p2e14.6)')aJG,aJL
c	write(*,'(1p2e14.6)')aJG,aJL
	aJL = aJL*dJl
	if(aJl.lt.ajlmax*djl) goto 5
	write(6,'(/)')



c
c	Launches Gnuplot
c
	close(6);close(7)
c	Ier=System('P:\Gnuplot\bin\wgnuplot.exe VertTD02.plt')
	Ier=System('wgnuplot.exe VertTD02.plt')
	if(Ier.ne.0)
	&write(*,'('' Gnuplot script launch was not successful :'',i3)')Ier
	end


	subroutine lire(titre,n,parname,par,form)
c
c
c		menu de lecture et changement des parametres
c
c
c	titre..........chaine de caracteres titre du menu (40 car)
c	n..............nombre de parametres
c	parname........character*40 a n elements
c	par............tableau reel*4 a n elements au moins
c	               servant au passage des parametres
c	form...........caracter*5 donnant le format d'ecriture des
c	               nombres
c
c
c
	implicit real*8 (a-h,o-z)
	character*(*) form
	character*31 ffor
	character*40 titre,parname(n)
	character*1 esc
	dimension par(n)
	esc=char(27)
c
c
c		calcule le format d'ecriture du tableau
c
c
	write(ffor,100)form
c100	format(23h(i3,' ---> ',a40,' : ',,a5,1h))
100	format(23h(i3,' ---> ',a40,' : ',,a7,1h))
c
c
c	efface l'ecran et affiche le titre en dble largeur
c
c
c	write(*,'(1x,a1,''[2J''\)')esc
	write(*,'(1x,t20,a40/)')titre
c
c	ecrit les variables et leurs valeurs,puis le message
c	d'interrogation et efface la reponse precedente
c
50	write(*,ffor)(i,parname(i),par(i),i=1,n)
	write(*,'(//'' Entrer le numero du parametre,nouvelle valeur'')')
c	write(*,'('' taper 0,0 pour sortir du menu''/
c     *            '' taper -1,0 pour arreter  --->'',a1,''[K''\)')esc
	write(*,'('' taper 0,0 pour sortir du menu''/
     *            '' taper -1,0 pour arreter  --->''\)')
c
c	lecture de l'indice et de la valeur
c
   	read(*,*,err=200,end=300)i,val
	if(i.gt.0..and.i.le.n) par(i)=val
c
c	test de sortie
c
	
400	continue
	if(i.eq.0) then
c	write(*,'('' Retour au programme appelant'')')
	return
	endif
	if(i.lt.0)stop'Retour DOS' 
c
c	retourne en haut de l'ecran
c	descend de deux lignes et va en bout de ligne precedente (<-)
c	pour se retrouver au debut de la liste des variables
c
c	write(*,'(1x,a1,''[2;1f'')')esc
	goto 50
c
c	erreur de lecture on sort du menu
c
200	i=0
	goto 400
c
c	fin de fichier on sort du programme retour dos
c
300	i=-1
	goto 400
	end
